'use strict'

exports.__esModule = true
exports.FlexItem = void 0

var _propTypes = _interopRequireDefault(require('prop-types'))

var React = _interopRequireWildcard(require('react'))

var _clsx = _interopRequireDefault(require('clsx'))

var _Frame = require('./Frame')

var _Layout = require('./Layout')

var _styles = require('./styles')

function _getRequireWildcardCache() {
  if (typeof WeakMap !== 'function') return null
  var cache = new WeakMap()
  _getRequireWildcardCache = function () {
    return cache
  }
  return cache
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj
  }
  if (obj === null || (typeof obj !== 'object' && typeof obj !== 'function')) {
    return {default: obj}
  }
  var cache = _getRequireWildcardCache()
  if (cache && cache.has(obj)) {
    return cache.get(obj)
  }
  var newObj = {}
  var hasPropertyDescriptor =
    Object.defineProperty && Object.getOwnPropertyDescriptor
  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor
        ? Object.getOwnPropertyDescriptor(obj, key)
        : null
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc)
      } else {
        newObj[key] = obj[key]
      }
    }
  }
  newObj.default = obj
  if (cache) {
    cache.set(obj, newObj)
  }
  return newObj
}

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj}
}

const __reactCreateElement__ = React.createElement
const FlexItem = React.forwardRef(
  (
    {
      className,
      align,
      order,
      basis,
      maxWidth,
      maxHeight,
      grow,
      shrink,
      ...props
    },
    ref
  ) => {
    const prop = (0, _Layout.useLayout)().mq.prop
    return /*#__PURE__*/ __reactCreateElement__(_Frame.Frame, {
      ref: ref,
      className: (0, _clsx.default)(
        className,
        prop(maxWidthStyle, maxWidth),
        prop(maxHeightStyle, maxHeight),
        prop(basisStyle, basis),
        prop(_styles.alignSelf, align),
        prop(orderStyle, order),
        prop(growStyle, grow),
        prop(shrinkStyle, shrink)
      ),
      ...props,
    })
  }
)
exports.FlexItem = FlexItem

const maxWidthStyle = (maxWidth) => ({
  maxWidth,
})

const maxHeightStyle = (maxHeight) => ({
  maxHeight,
})

const basisStyle = (basis) => ({
  basis,
})

const orderStyle = (order) => ({
  order,
})

const growStyle = (grow) => ({
  flexGrow: grow === true ? 1 : grow === false ? 0 : grow,
})

const shrinkStyle = (shrink) => ({
  flexShrink: shrink === true ? 1 : shrink === false ? 0 : shrink,
})
