'use strict'

exports.__esModule = true
exports.Frame = void 0

var _propTypes = _interopRequireDefault(require('prop-types'))

var React = _interopRequireWildcard(require('react'))

var _clsx = _interopRequireDefault(require('clsx'))

var _Layout = require('./Layout')

function _getRequireWildcardCache() {
  if (typeof WeakMap !== 'function') return null
  var cache = new WeakMap()
  _getRequireWildcardCache = function () {
    return cache
  }
  return cache
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj
  }
  if (obj === null || (typeof obj !== 'object' && typeof obj !== 'function')) {
    return {default: obj}
  }
  var cache = _getRequireWildcardCache()
  if (cache && cache.has(obj)) {
    return cache.get(obj)
  }
  var newObj = {}
  var hasPropertyDescriptor =
    Object.defineProperty && Object.getOwnPropertyDescriptor
  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor
        ? Object.getOwnPropertyDescriptor(obj, key)
        : null
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc)
      } else {
        newObj[key] = obj[key]
      }
    }
  }
  newObj.default = obj
  if (cache) {
    cache.set(obj, newObj)
  }
  return newObj
}

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj}
}

const __reactCreateElement__ = React.createElement
const Frame = React.forwardRef(
  (
    {
      as: As = 'div',
      className,
      display,
      position,
      width,
      height,
      size,
      pad,
      bg,
      elevation,
      radius,
      ...props
    },
    ref
  ) => {
    const prop = (0, _Layout.useLayout)().mq.prop
    return /*#__PURE__*/ __reactCreateElement__(As, {
      ref: ref,
      className: (0, _clsx.default)(
        className,
        prop(frameStyle, display),
        prop(frameStyle, position),
        prop(widthStyle, width),
        prop(heightStyle, height),
        prop(sizeStyle, size),
        prop(padStyle, pad),
        prop(bgStyle, bg),
        prop(elevationStyle, elevation),
        prop(radiusStyle, radius)
      ),
      ...props,
    })
  }
)
exports.Frame = Frame
Frame.propTypes = {
  as: _propTypes.default.oneOfType([
    _propTypes.default.any,
    _propTypes.default.elementType,
  ]),
  className: _propTypes.default.oneOfType([
    _propTypes.default.string,
    _propTypes.default.arrayOf(_propTypes.default.string),
  ]),
}
const frameStyle = {
  flex: `display:flex;`,
  inlineFlex: `display:inline-flex;`,
  block: `display:block;`,
  inlineBlock: `display:inline-block;`,
  inline: `display:inline;`,
  none: `display:none;`,
  relative: `position:relative;`,
  absolute: `position:absolute;`,
  sticky: `position:sticky;`,
  fixed: `position:fixed;`,
}

const widthStyle = (width) => ({
  width,
})

const heightStyle = (height) => ({
  height,
})

const sizeStyle = (size) => ({
  width: size,
  height: size,
})

const padStyle = (padProp) => ({pad}) => {
  function _ref(k) {
    return pad[k]
  }

  if (Array.isArray(padProp)) {
    return {
      padding: padProp.map(_ref).join(' '),
    }
  }

  return `padding:${pad[padProp]};`
} // @ts-ignore

const bgStyle = (bg) => ({color}) => `background:${color[bg]};` // @ts-ignore

const elevationStyle = (elevationProp) => ({elevation}) =>
  `box-shadow:${elevation[elevationProp]};` // @ts-ignore

const radiusStyle = (radiusProp) => ({radius}) => {
  function _ref2(k) {
    return radius[k]
  }

  if (Array.isArray(radiusProp)) {
    return {
      borderRadius: radiusProp.map(_ref2).join(' '),
    }
  }

  return `border-radius:${radius[radiusProp]};`
}
