'use strict'

exports.__esModule = true
exports.flexDirection = exports.alignContent = exports.justifyContent = exports.justifyItems = exports.justifySelf = exports.alignSelf = exports.alignItems = void 0
const alignItems = {
  start: `align-items:flex-start;`,
  center: `align-items:center;`,
  end: `align-items:flex-end;`,
  baseline: `align-items:baseline;`,
  stretch: `align-items:stretch;`,
}
exports.alignItems = alignItems
const aiEntries = Object.entries(alignItems)

const replaceReducer = (from, to) => (current, [key, value]) => {
  current[key] = value.replace(from, to)
  return current
}

const alignSelf = aiEntries.reduce(replaceReducer('items', 'self'), {})
exports.alignSelf = alignSelf
const justifySelf = aiEntries.reduce(
  replaceReducer('align-items', 'justify-self'),
  {}
)
exports.justifySelf = justifySelf
const justifyItems = aiEntries.reduce(replaceReducer('align', 'justify'), {})
exports.justifyItems = justifyItems
const justifyContent = {
  start: `justify-content:flex-start;`,
  center: `justify-content:center;`,
  end: `justify-content:flex-end;`,
  around: `justify-content:space-around;`,
  between: `justify-content:space-between;`,
  evenly: `justify-content:space-evenly;`,
  stretch: `justify-content:stretch;`,
}
exports.justifyContent = justifyContent
const alignContent = Object.entries(justifyContent).reduce(
  replaceReducer('justify', 'align'),
  {}
)
exports.alignContent = alignContent
const flexDirection = {
  row: `flex-direction:row;`,
  column: `flex-direction:column;`,
  reversedRow: `flex-direction:row-reverse;`,
  reversedColumn: `flex-direction:column-reverse;`,
}
exports.flexDirection = flexDirection
