'use strict'

exports.__esModule = true
exports.unit = void 0

var _unitless = _interopRequireDefault(require('@emotion/unitless'))

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj}
}

const isCustomProperty = (property) => property.charCodeAt(1) === 45

const unit = (key, value) =>
  _unitless.default[key] !== 1 &&
  !isCustomProperty(key) &&
  typeof value === 'number' &&
  value !== 0
    ? `${value}px`
    : value

exports.unit = unit
