import _pt from 'prop-types'
import * as React from 'react'
const __reactCreateElement__ = React.createElement
import clsx from 'clsx'
import {useLayout} from './Layout'
export const Frame = React.forwardRef(
  (
    {
      as: As = 'div',
      className,
      display,
      position,
      width,
      height,
      size,
      pad,
      bg,
      elevation,
      radius,
      ...props
    },
    ref
  ) => {
    const prop = useLayout().mq.prop
    return /*#__PURE__*/ __reactCreateElement__(As, {
      ref: ref,
      className: clsx(
        className,
        prop(frameStyle, display),
        prop(frameStyle, position),
        prop(widthStyle, width),
        prop(heightStyle, height),
        prop(sizeStyle, size),
        prop(padStyle, pad),
        prop(bgStyle, bg),
        prop(elevationStyle, elevation),
        prop(radiusStyle, radius)
      ),
      ...props,
    })
  }
)
Frame.propTypes = {
  as: _pt.oneOfType([_pt.any, _pt.elementType]),
  className: _pt.oneOfType([_pt.string, _pt.arrayOf(_pt.string)]),
}
const frameStyle = {
  flex: `display:flex;`,
  inlineFlex: `display:inline-flex;`,
  block: `display:block;`,
  inlineBlock: `display:inline-block;`,
  inline: `display:inline;`,
  none: `display:none;`,
  relative: `position:relative;`,
  absolute: `position:absolute;`,
  sticky: `position:sticky;`,
  fixed: `position:fixed;`,
}

const widthStyle = (width) => ({
  width,
})

const heightStyle = (height) => ({
  height,
})

const sizeStyle = (size) => ({
  width: size,
  height: size,
})

const padStyle = (padProp) => ({pad}) => {
  function _ref(k) {
    return pad[k]
  }

  if (Array.isArray(padProp)) {
    return {
      padding: padProp.map(_ref).join(' '),
    }
  }

  return `padding:${pad[padProp]};`
} // @ts-ignore

const bgStyle = (bg) => ({color}) => `background:${color[bg]};` // @ts-ignore

const elevationStyle = (elevationProp) => ({elevation}) =>
  `box-shadow:${elevation[elevationProp]};` // @ts-ignore

const radiusStyle = (radiusProp) => ({radius}) => {
  function _ref2(k) {
    return radius[k]
  }

  if (Array.isArray(radiusProp)) {
    return {
      borderRadius: radiusProp.map(_ref2).join(' '),
    }
  }

  return `border-radius:${radius[radiusProp]};`
}
