import _pt from 'prop-types'
import * as React from 'react'
const __reactCreateElement__ = React.createElement
import clsx from 'clsx'
import {Frame} from './Frame'
import {useLayout} from './Layout'
import {
  alignSelf,
  justifySelf,
  alignItems,
  justifyItems,
  justifyContent,
  alignContent,
} from './styles'
import {unit} from './utils'
export const Grid = React.forwardRef(
  (
    {
      className,
      alignX,
      alignY,
      cols,
      distributeX,
      distributeY,
      gap,
      inline,
      rows,
      ...props
    },
    ref
  ) => {
    const prop = useLayout().mq.prop
    return /*#__PURE__*/ __reactCreateElement__(Frame, {
      ref: ref,
      className: clsx(
        className,
        prop(gridStyle, inline || false),
        prop(colsStyle, cols),
        prop(rowsStyle, rows),
        prop(justifyItems, alignX),
        prop(alignItems, alignY),
        prop(justifyContent, distributeX),
        prop(alignContent, distributeY),
        prop(gapStyle, gap)
      ),
      ...props,
    })
  }
)
export const GridItem = React.forwardRef(
  (
    {className, alignX, alignY, colStart, colEnd, rowStart, rowEnd, ...props},
    ref
  ) => {
    const prop = useLayout().mq.prop
    return /*#__PURE__*/ __reactCreateElement__(Frame, {
      ref: ref,
      className: clsx(
        className,
        prop(justifySelf, alignX),
        prop(alignSelf, alignY),
        prop(colStartStyle, colStart),
        prop(colEndStyle, colEnd),
        prop(rowStartStyle, rowStart),
        prop(rowEndStyle, rowEnd)
      ),
      ...props,
    })
  }
)

const gridStyle = (inline) => ({
  display: inline ? 'inline-grid' : 'grid',
})

function _ref(col) {
  return unit('grid-template-columns', col)
}

const colsStyle = (cols) => {
  let value
  if (Array.isArray(cols)) value = cols
  // ie doesn't have repeat
  else value = new Array(cols).fill('1fr')
  return {
    gridTemplateColumns: value.map(_ref).join(' '),
  }
}

function _ref2(col) {
  return unit('grid-template-rows', col)
}

const rowsStyle = (rows) => {
  let value
  if (Array.isArray(rows)) value = rows
  // ie doesn't have repeat
  else value = new Array(rows).fill('1fr')
  return {
    gridTemplateRows: value.map(_ref2).join(' '),
  }
}

const gapStyle = (gapProp) => ({gap}) => ({
  gridGap: Array.isArray(gapProp)
    ? gapProp.map((p) => gap[p]).join(' ')
    : `${gap[gapProp]} ${gap[gapProp]}`,
})

const colStartStyle = (gridColumnStart) => ({
  gridColumnStart,
})

const colEndStyle = (gridColumnEnd) => ({
  gridColumnEnd,
})

const rowStartStyle = (gridRowStart) => ({
  gridRowStart,
})

const rowEndStyle = (gridRowEnd) => ({
  gridRowEnd,
})
