import _pt from 'prop-types'
import * as React from 'react'
const __reactCreateElement__ = React.createElement
import defaultStyles, {useDash} from '@-ui/react'
import dashMq from '@-ui/mq'
const defaultMq = dashMq({})

defaultMq.prop = (styleGetter, value) => {
  if (value === void 0) return
  /* istanbul ignore next */

  if (__DEV__) {
    if (typeof value === 'object' && !Array.isArray(value)) {
      throw new Error(
        '@-ui/layout is attempting to use media queries without a <LayoutProvider> component. This is not allowed.'
      )
    }
  } // Single style

  return defaultStyles.one(
    typeof styleGetter === 'function'
      ? styleGetter(value)
      : typeof value === 'string'
      ? styleGetter[value]
      : ''
  )()
}

const LayoutContext = React.createContext({
  styles: defaultStyles,
  mediaQueries: {},
  mq: defaultMq,
})
export const useLayout = () => React.useContext(LayoutContext)
const emptyObj = {}
export const LayoutProvider = ({mediaQueries = emptyObj, children}) => {
  const styles = useDash()
  const context = React.useMemo(() => {
    const mq = dashMq(mediaQueries)

    mq.prop = (styleGetter, value, context) => {
      if (value === void 0) return

      function _ref(stylesWithMq, queryName) {
        const queryValue = value[queryName]

        if (value[queryName] !== void 0) {
          stylesWithMq[queryName] =
            typeof styleGetter === 'function'
              ? styleGetter(queryValue, queryName, context)
              : styleGetter[queryValue]
        }

        return stylesWithMq
      }

      if (typeof value === 'object' && !Array.isArray(value)) {
        // Media queries
        const mqObj = mq(Object.keys(mediaQueries).reduce(_ref, {}))
        return styles.one(mqObj)()
      } // Single style

      return styles.one(
        typeof styleGetter === 'function'
          ? styleGetter(value)
          : typeof value === 'string'
          ? styleGetter[value]
          : ''
      )()
    }

    return {
      styles,
      mediaQueries,
      mq,
    }
  }, [styles, mediaQueries])
  return /*#__PURE__*/ __reactCreateElement__(LayoutContext.Provider, {
    value: context,
    children: children,
  })
}
LayoutProvider.propTypes = {
  mediaQueries: _pt.object,
}
